Index: apps/settings.c
===================================================================
RCS file: /cvsroot/rockbox/apps/settings.c,v
retrieving revision 1.437
diff -u -r1.437 settings.c
--- apps/settings.c	13 Nov 2006 00:45:20 -0000	1.437
+++ apps/settings.c	15 Nov 2006 08:00:24 -0000
@@ -772,388 +168,953 @@
 }
 #endif
 
-/*
- * Calculates the checksum for the config block and returns it
- */
-
-static unsigned short calculate_config_checksum(const unsigned char* buf)
+void write_settings_to_disk(void)
 {
-    unsigned int i;
-    unsigned char cksum[2];
-    cksum[0] = cksum[1] = 0;
-
-    for (i=0; i < RTC_BLOCK_SIZE - 2; i+=2 ) {
-        cksum[0] ^= buf[i];
-        cksum[1] ^= buf[i+1];
-    }
-
-    return (cksum[0] << 8) | cksum[1];
+#ifndef SIMULATOR
+    if (ata_disk_is_active())
+        settings_save_config(ROCKBOX_CONFIGFILE,false);
+    else 
+#endif
+        settings_save();
 }
 
-/*
- * initialize the config block buffer
- */
-static void init_config_buffer( void )
+bool settings_save_ata_cb( void )
 {
-    DEBUGF( "init_config_buffer()\n" );
-
-    /* reset to 0 - all unused */
-    memset(config_block, 0, CONFIG_BLOCK_SIZE);
-    /* insert header */
-    config_block[0] = 'R';
-    config_block[1] = 'o';
-    config_block[2] = 'c';
-    config_block[3] = CONFIG_BLOCK_VERSION;
+#ifndef SIMULATOR
+    queue_broadcast(SYS_DUMPSETTINGS,0); /*hopefully only the main thread 
+                                           will accept use this, so it 
+                                           shouldnt stkOv! */
+#else
+    write_settings_to_disk();
+#endif
+    return 0;
 }
 
-bool flush_config_block_callback(void)
-{
-    ata_write_sectors(IF_MV2(0,) config_sector, 1, config_block);
-    return true;
-}
-/*
- * save the config block buffer to disk or RTC RAM
- */
-static int save_config_buffer( void )
+int settings_save( void )
 {
-    unsigned short chksum;
-#ifdef HAVE_RTC_RAM
-    unsigned int i;
-#endif
-
-    /* update the checksum in the end of the block before saving */
-    chksum = calculate_config_checksum(config_block);
-    config_block[ RTC_BLOCK_SIZE - 2 ] = chksum >> 8;
-    config_block[ RTC_BLOCK_SIZE - 1 ] = chksum & 0xff;
-
-#ifdef HAVE_RTC_RAM
-    /* FIXME: okay, it _would_ be cleaner and faster to implement rtc_write so
-       that it would write a number of bytes at a time since the RTC chip
-       supports that, but this will have to do for now 8-) */
-    for (i=0; i < RTC_BLOCK_SIZE; i++ ) {
-        int r = rtc_write(0x14+i, config_block[i]);
-        if (r) {
-            DEBUGF( "save_config_buffer: rtc_write failed at addr 0x%02x: %d\n",
-                    14+i, r );
-            return r;
-        }
-    }
-
-#endif
-
-    if (config_sector != 0)
-        register_ata_idle_func(flush_config_block_callback);
-    else
-        return -1;
-
+    register_ata_idle_func(settings_save_ata_cb);
     return 0;
 }
 
-/*
- * load the config block buffer from disk or RTC RAM
- */
-static int load_config_buffer(int which)
+void save_item_to_gs(const struct settings_list *item, char* new_val)
 {
-    unsigned short chksum;
-    bool correct = false;
-
-
-    DEBUGF( "load_config_buffer()\n" );
-
-    if (which & SETTINGS_HD)
+    switch (item->flags&F_T_MASK)
     {
-        if (config_sector != 0) {
-            ata_read_sectors(IF_MV2(0,) config_sector, 1,  config_block);
-            /* calculate the checksum, check it and the header */
-            chksum = calculate_config_checksum(config_block);
-
-            if (config_block[0] == 'R' &&
-                config_block[1] == 'o' &&
-                config_block[2] == 'c' &&
-                config_block[3] == CONFIG_BLOCK_VERSION &&
-                (chksum >> 8) == config_block[RTC_BLOCK_SIZE - 2] &&
-                (chksum & 0xff) == config_block[RTC_BLOCK_SIZE - 1])
+        case F_T_INT:
+#ifdef HAVE_LCD_COLOR
+            if (item->flags&F_STORERGB)
             {
-                DEBUGF( "load_config_buffer: header & checksum test ok\n" );
-                correct = true;
+                *(int*)item->setting = hex_to_rgb(new_val);
             }
-        }
+            else 
+#endif
+                 if (item->flags&F_STOREREALVALUE)
+                        *(int*)item->setting
+                        = atoi(new_val);
+            else if (item->flags&F_T_CHOICE)
+            {
+                int i;
+                if (item->flags&F_LANG_STRING)
+                {
+                    for (i=0;i<item->nb_values;i++)
+                    {
+                        if (!strcmp(new_val, item->strings[i]))
+                        {
+                            *(int*)item->setting = i;
+                            break;
+                        }
+                    }
+                }
+                else
+                {
+                    char *start, *end;
+                    int len = strlen(new_val);
+                    start = strchr(item->conf_file_info,',');
+                    if (!start)
+                        break;
+                    end = strchr(++start,',');
+                    i = 0;
+                    while (start)
+                    {
+                        if (!strncmp(start,new_val, MAX(((end?end:0)-start),len)))
+                        {
+                            *(int*)item->setting = i;
+                            break;
+                        }
+                        i++;
+                        start = end+1;
+                        if (end)
+                            end = strchr(++end,',');
+                    }
+                }
+            }
+            else *(int*)item->setting = atoi(new_val);
+            break;
+        case F_T_UINT:
+            *(unsigned int*)item->setting = 
+                    (unsigned int)atoi(new_val);
+            break;
+        case F_T_BOOL:
+            if (!strcmp(new_val,"on"))
+                *(bool*)item->setting = true;
+            else *(bool*)item->setting = false;
+            break;
+        case F_T_CHARPTR:
+        case F_T_UCHARPTR:
+            if (item->flags&F_FILENAMEONLY && 
+                strrchr(new_val,'/'))
+            {
+                set_file(new_val,
+                         (char*)item->setting,MAX_FILENAME);
+            }
+            else strcpy((char*)item->setting,new_val);
+            break;
     }
+}
+bool check_setting_name(char* from_file, char* in_settings)
+{
+    int len = strlen(from_file);
+    return !strncmp(from_file,in_settings,len) &&
+            ( ( in_settings[len] == ',') ||
+                    ( in_settings[len] == '\0'));
+}
 
-#ifdef HAVE_RTC_RAM
-    if(!correct)
-    {
-        /* If the disk sector was incorrect, reinit the buffer */
-        memset(config_block, 0, CONFIG_BLOCK_SIZE);
-    }
+bool settings_load_config(const char* file)
+{
+    int fd;
+    char line[256];
+    char* name;
+    char* value;
+    int pos; /* currently returned position */
+    const struct settings_list *item;
+    bool persistant = false;
+    
+    fd = open(file, O_RDONLY);
+    if (fd < 0)
+        return false;
 
-    if (which & SETTINGS_RTC)
+    while (read_line(fd, line, sizeof line) > 0)
     {
-        unsigned int i;
-        unsigned char rtc_block[RTC_BLOCK_SIZE];
+        if (!settings_parseline(line, &name, &value))
+            continue;
 
-        /* read rtc block */
-        for (i=0; i < RTC_BLOCK_SIZE; i++ )
-            rtc_block[i] = rtc_read(0x14+i);
-
-        chksum = calculate_config_checksum(rtc_block);
-
-        /* if rtc block is ok, use that */
-        if (rtc_block[0] == 'R' &&
-            rtc_block[1] == 'o' &&
-            rtc_block[2] == 'c' &&
-            rtc_block[3] == CONFIG_BLOCK_VERSION &&
-            (chksum >> 8) == rtc_block[RTC_BLOCK_SIZE - 2] &&
-            (chksum & 0xff) == rtc_block[RTC_BLOCK_SIZE - 1])
+        if (name[0] == '~') /* load the value, and dont save the new value to disk */
         {
-            memcpy(config_block, rtc_block, RTC_BLOCK_SIZE);
-            correct = true;
+            persistant = true;
+            name++;
         }
-    }
-#endif
+        else persistant = false;
 
-    if ( !correct ) {
-        /* if checksum is not valid, clear the config buffer */
-        DEBUGF( "load_config_buffer: header & checksum test failed\n" );
-        init_config_buffer();
-        return -1;
+        for (pos = 0; pos < nb_settings ; pos++)
+        {
+            item = &settings[pos];
+            
+            if (item->flags&(F_SYSTEMSETTING|F_T_CHARPTR|F_LANG_IS_STRING))
+            {
+                if (!strcmp(name,item->cfg_string))
+                {
+                    if (persistant)
+                        add_to_persistant(item,value);
+                    save_item_to_gs(item,value);
+                    break;
+                }
+            }
+            else if (check_setting_name(name,item->conf_file_info))
+            {
+                if (persistant)
+                    add_to_persistant(item,value);
+                save_item_to_gs(item,value);
+                break;
+            }
+        } /* for (...) */
     }
 
-    return 0;
+    close(fd);
+    settings_apply(false);
+    return true;
 }
-
-
-/* helper to save content of global_settings into a bitfield,
-   as described per table */
-static void save_bit_table(const struct bit_entry* p_table, int count, int bitstart)
+#ifdef HAVE_RTC_RAM
+bool load_from_rtc(int rtc_item, int *value)
 {
-    uint32_t *p_bitfield = (uint32_t *)config_block; /* 32 bit addr. */
-    uint32_t value; /* 32 bit content */
-    int i;
-    const struct bit_entry* p_run = p_table; /* start after the size info */
-    int curr_bit = bitstart + p_table->bit_size;
-    count--; /* first is excluded from loop */
-
-    for (i=0; i<count; i++)
+    if (!rtc_read_multiple(0x14+(rtc_item*4),(char*)value,4))
+        return true;
+    return false;
+}
+    
+bool save_to_rtc(int rtc_item, int value)
+{
+    union { int i; char c[4]; } storage;
+    int j = 0;
+    int ret=0, address = 0x14+(rtc_item*4);
+    storage.i = value;
+    for(j=0; j<4 && ret==0;j++)
     {
-        p_run++;
-        /* could do a memcpy, but that would be endian-dependent */
-        switch(p_run->byte_size)
-        {
-        case 1:
-            value = ((uint8_t *)&global_settings)[p_run->settings_offset];
-            break;
-        case 2:
-            value = ((uint16_t *)&global_settings)[p_run->settings_offset/2];
-            break;
-        case 4:
-            value = ((uint32_t *)&global_settings)[p_run->settings_offset/4];
-            break;
-        default:
-            DEBUGF( "save_bit_table: illegal size!\n" );
-            continue;
-        }
-        set_bits(p_bitfield, curr_bit, p_run->bit_size & 0x3F, value);
-        curr_bit += p_run->bit_size & 0x3F;
+        ret = rtc_write(address+j, storage.c[j]);
     }
-    set_bits(p_bitfield, bitstart, p_table->bit_size, /* write size */
-        curr_bit); /* = position after last element */
+    return (ret==0) ? true : false;
 }
-
+#endif
 /*
- * figure out the config sector from the partition table and the
- * mounted file system
+ * load settings from disk or RTC RAM
  */
-void settings_calc_config_sector(void)
+void settings_load(int which)
 {
-#ifdef SIMULATOR
-    config_sector = 61;
-#else
-    int i;
-    long partition_start;
-    long sector = 0;
-
-    if (fat_startsector(IF_MV(0)) != 0)    /* There is a partition table */
+    DEBUGF( "reload_all_settings()\n" );
+#ifdef HAVE_RTC_RAM
+    if (which&SETTINGS_RTC)
     {
-        sector = 61;
-        for (i = 0; i < 4; i++)
+        int i, value, rtc_item = 0;
+        bool config_ok = false;
+        if (load_from_rtc(rtc_item,&value) == true)
         {
-            partition_start = disk_partinfo(i)->start;
-            if (partition_start != 0 && (partition_start - 2) < sector)
-                sector = partition_start - 2;
+            if (value == RTC_RAM_CONFIG_VERSION)
+                config_ok = true;
         }
-        if (sector < 0)
-            sector = 0;
-    }
-
-    config_sector = sector;
-#endif
-}
-
+        rtc_item++;
+        for (i=0; i<nb_settings; i++)
+        {
+            if (settings[i].flags&F_SAVETORTC)
+            {
+                if (config_ok == true)
+                {
+                    if (load_from_rtc(rtc_item++,
+                        (int*)settings[i].setting) == false)
+                    {
+                        *(int*)settings[i].setting
+                                = settings[i].default_val.int_;
+                    }
+                }
+                else *(int*)settings[i].setting
+                            = settings[i].default_val.int_;
+            }
+        }
+    }
+#endif
+    if (which&SETTINGS_HD)
+    {
+        settings_load_config(ROCKBOX_CONFIGFILE);
+    }
+}
+
+void set_file(char* filename, char* setting, int maxlen)
+{
+    char* fptr = strrchr(filename,'/');
+    int len;
+    int extlen = 0;
+    char* ptr;
+
+    if (!fptr)
+        return;
+
+    *fptr = 0;
+    fptr++;
+
+    len = strlen(fptr);
+    ptr = fptr + len;
+    while ((*ptr != '.') && (ptr != fptr)) {
+        extlen++;
+        ptr--;
+    }
+    if(ptr == fptr) extlen = 0;
+
+    if (strncasecmp(ROCKBOX_DIR, filename ,strlen(ROCKBOX_DIR)) ||
+        (len-extlen > maxlen))
+        return;
+
+    strncpy(setting, fptr, len-extlen);
+    setting[len-extlen]=0;
+    settings_save();
+}
+
 /*
- * persist all runtime user settings to disk or RTC RAM
+ * reset all settings to their default value
  */
-int settings_save( void )
+void settings_reset(void) 
 {
-    int i;
+    int i; 
+    const struct settings_list *item;
+    DEBUGF( "settings_reset()\n" );
 
+    for (i = 0; i < nb_settings ; i++)
     {
-        int elapsed_secs;
+        item = &settings[i];         
+        if (item->flags&F_T_SOUND)
+        {
+            *(int*)item->setting
+                    = sound_default(item->values[0]);
+            continue;
+        }
+        switch (item->flags&F_T_MASK)
+        {
+            case F_T_INT:
+                *(int*)item->setting
+                        = item->default_val.int_;
+                break;
+            case F_T_UINT:
+                *(unsigned int*)item->setting
+                        = item->default_val.uint_;
+                break;
+            case F_T_BOOL:
+                *(bool*)item->setting
+                        = item->default_val.bool_;
+                break;
+            case F_T_CHARPTR:
+            case F_T_UCHARPTR:
+                strcpy((char*)item->setting,
+                        item->default_val.charptr);
+                break;
+        }
+    } /* for (...) */
+}
 
-        elapsed_secs = (current_tick - lasttime) / HZ;
-        global_settings.runtime += elapsed_secs;
-        lasttime += (elapsed_secs * HZ);
-
-        if ( global_settings.runtime > global_settings.topruntime )
-            global_settings.topruntime = global_settings.runtime;
-    }
-
-    /* serialize scalar values into RTC and HD sector, specified via table */
-    save_bit_table(rtc_bits, sizeof(rtc_bits)/sizeof(rtc_bits[0]), 4*8);
-    save_bit_table(hd_bits, sizeof(hd_bits)/sizeof(hd_bits[0]), RTC_BLOCK_SIZE*8);
-
-    i = 0xb8;
-    strncpy((char *)&config_block[i], (char *)global_settings.wps_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-    strncpy((char *)&config_block[i], (char *)global_settings.lang_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-    strncpy((char *)&config_block[i], (char *)global_settings.font_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-#ifdef HAVE_REMOTE_LCD
-    strncpy((char *)&config_block[i], (char *)global_settings.rwps_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
+bool settings_save_config(const char* filename, bool theme)
+{
+    int fd;
+    int i, value = 0, type;
+    int j;
+    bool persistant = false;
+    char name[256], *char_value;
+    const struct settings_list *item;
+    
+#ifdef HAVE_RTC_RAM
+    j = 0;
+    save_to_rtc(j++, RTC_RAM_CONFIG_VERSION);
+    for (i=0; i<nb_settings; i++)
+    {
+        if (settings[i].flags&F_SAVETORTC)
+        {
+            value = *(int*)settings[i].setting;
+            save_to_rtc(j++, value);
+        }
+    }
 #endif
 
-#ifdef CONFIG_TUNER
-    strncpy((char *)&config_block[i], (char *)global_settings.fmr_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-#endif
+    fd = creat(filename, O_WRONLY);
+    if (fd < 0)
+        return false;
+    
+    fdprintf(fd, "#\r\n# .cfg file created by rockbox %s - "
+            "http://www.rockbox.org\r\n#\r\n\r\n", appsversion);
+    
+    for (i=0; i < nb_settings; i++)
+    {
+        persistant = false;
+        item = &settings[i];
+        if (theme && ((item->flags&F_THEMESETTING) == 0))
+            continue;
+        type = item->flags&F_T_MASK;
+        if (item->flags&F_LANG_IS_STRING)
+            strcpy(name,item->cfg_string);
+        else 
+        {
+            char *p = strchr(item->conf_file_info,',');
+            if (p)
+            {
+                strncpy(name,item->conf_file_info,p-item->conf_file_info);
+                name[p-item->conf_file_info] = '\0';
+            }
+            else strcpy(name,item->conf_file_info);
+        }
+        
+        char_value = NULL;
 
-#if LCD_DEPTH > 1
-    strncpy((char *)&config_block[i], (char *)global_settings.backdrop_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-#endif
-#ifdef HAVE_LCD_BITMAP
-    strncpy((char *)&config_block[i], (char *)global_settings.kbd_file,
-            MAX_FILENAME);
-    i+= MAX_FILENAME;
-#endif
+        for (j=0; j<persistant_vars_count; j++)
+        {
+            if (persistant_variables[j].setting == item->setting)
+            {
+                persistant = true;
+                char_value = persistant_variables[j].value;
+                break;
+            }
+        }
 
-    if(save_config_buffer())
-    {
-        lcd_clear_display();
-#ifdef HAVE_REMOTE_LCD
-        lcd_remote_clear_display();
-#endif
-#ifdef HAVE_LCD_CHARCELLS
-        lcd_puts(0, 0, str(LANG_SETTINGS_SAVE_PLAYER));
-        lcd_puts(0, 1, str(LANG_SETTINGS_BATTERY_PLAYER));
-#else
-        lcd_puts(4, 2, str(LANG_SETTINGS_SAVE_RECORDER));
-        lcd_puts(2, 4, str(LANG_SETTINGS_BATTERY_RECORDER));
-        lcd_update();
-#ifdef HAVE_REMOTE_LCD
-        lcd_remote_puts(4, 2, str(LANG_SETTINGS_SAVE_RECORDER));
-        lcd_remote_puts(2, 4, str(LANG_SETTINGS_BATTERY_RECORDER));
-        lcd_remote_update();
-#endif
+        if (persistant == false)
+        {
+            switch (type)
+            {
+                case F_T_INT:
+                    value = *(int*)item->setting;
+                    if ((item->flags&(F_T_CHOICE|F_SYSTEMSETTING|
+                            F_STORERGB|F_T_SOUND|F_STOREREALVALUE)) == 0)
+                        fdprintf(fd,"# %s - min=%d, max=%d, step=%d\r\n",
+                            name,item->values[0],item->values[1],
+                            item->values[2]);
+                    break;
+                case F_T_UINT:
+                    value = *(unsigned int*)item->setting;
+                    if ((item->flags&(F_T_CHOICE|F_SYSTEMSETTING|
+                            F_STORERGB|F_T_SOUND|F_STOREREALVALUE)) == 0)
+                        fdprintf(fd,"# %s - min=%d, max=%d, step=%d\r\n",
+                            name,
+                                item->values[0],item->values[1],item->values[2]);
+                    break;
+                case F_T_BOOL:
+                    char_value = 
+                            (*(bool*)item->setting==true)?
+                                    "on":"off";
+                    fdprintf(fd,"# %s - on, off\r\n",name);
+                    break;
+                case F_T_CHARPTR:
+                case F_T_UCHARPTR:
+                    char_value = (char*)item->setting;
+                    break;
+            }
+            if ((item->flags&F_T_CHOICE) && ((item->flags&F_STOREREALVALUE) == 0))
+            {
+                fdprintf(fd,"# %s - ", name);
+                if (item->flags&F_LANG_STRING)
+                {
+                    for(j=0;j<item->nb_values;j++)
+                        fdprintf(fd,"%s,", item->strings[j]);
+                    fdprintf(fd,"\r\n");
+                    char_value = item->strings[value];
+                }
+                else 
+                {
+                    char *p;
+                    p = strchr(item->conf_file_info,',');
+                    if (p)
+                    {
+                        p++;
+                        fdprintf(fd,"%s\r\n", p);
+                        for(j=0;j<value && *p;j++)
+                        {
+                            while (*p != ',' && *p)
+                                p++;
+                            if (*p) p++; /* skip over the comma */
+                        }
+                        char_value = p;
+                    }
+                    else char_value = item->conf_file_info;
+                }
+            }
+        } /* if (!persistant) */
+        
+#ifdef HAVE_LCD_COLOR
+        if (item->flags&F_STORERGB && char_value==NULL)
+        {
+            fdprintf(fd, "# %s - RRGGBB (hex values)\r\n%s: %02x%02x%02x\r\n",
+                    name,name,
+                    (int)RGB_UNPACK_RED(value),
+                    (int)RGB_UNPACK_GREEN(value),
+                    (int)RGB_UNPACK_BLUE(value));
+        }
+        else 
 #endif
-        sleep(HZ*2);
-        return -1;
-    }
-    return 0;
+        if (char_value == NULL)
+        {
+            fdprintf(fd,"%c%s: %d\r\n",(persistant == true)?'~':'\0',
+                     name, value);
+        }
+        else
+        {
+            char *p = strchr(char_value,',');
+            char text[128];
+            if (p)
+            {
+                strncpy(text,char_value,p-char_value);
+                text[p-char_value] = '\0';
+            }
+            else strcpy(text,char_value);
+            fdprintf(fd,"%c%s: %s\r\n",(persistant == true)?'~':'\0',
+                    name, text);
+        }
+    } /* for(...) */
+    close(fd);
+    return true;
+}
+bool set_bool(const char* string, bool* variable )
+{
+    return set_bool_options(string, variable,
+                            (char *)STR(LANG_SET_BOOL_YES),
+                            (char *)STR(LANG_SET_BOOL_NO),
+                            NULL);
 }
 
-#ifdef HAVE_LCD_BITMAP
-/**
- * Applies the range infos stored in global_settings to
- * the peak meter.
- */
-void settings_apply_pm_range(void)
+/* wrapper to convert from int param to bool param in set_option */
+static void (*boolfunction)(bool);
+void bool_funcwrapper(int value)
 {
-    int pm_min, pm_max;
+    if (value)
+        boolfunction(true);
+    else
+        boolfunction(false);
+}
 
-    /* depending on the scale mode (dBfs or percent) the values
-       of global_settings.peak_meter_dbfs have different meanings */
-    if (global_settings.peak_meter_dbfs)
+bool set_bool_options(const char* string, bool* variable,
+                      const char* yes_str, int yes_voice,
+                      const char* no_str, int no_voice,
+                      void (*function)(bool))
+{
+    struct opt_items names[] = {
+        {(unsigned char *)no_str, no_voice},
+        {(unsigned char *)yes_str, yes_voice}
+    };
+    bool result;
+
+    boolfunction = function;
+    result = set_option(string, variable, BOOL, names, 2,
+                        function ? bool_funcwrapper : NULL);
+    return result;
+}
+
+void talk_unit(int unit, int value)
+{
+    if (global_settings.talk_menu)
     {
-        /* convert to dBfs * 100          */
-        pm_min = -(((int)global_settings.peak_meter_min) * 100);
-        pm_max = -(((int)global_settings.peak_meter_max) * 100);
+        if (unit < UNIT_LAST)
+        {   /* use the available unit definition */
+            talk_value(value, unit, false);
+        }
+        else
+        {   /* say the number, followed by an arbitrary voice ID */
+            talk_number(value, false);
+            talk_id(unit, true);
+        }
     }
+}
+ 
+int selected_setting; /* Used by the callback */
+void dec_sound_formatter(char *buffer, int buffer_size, int val, const char * unit)
+{
+    val = sound_val2phys(selected_setting, val);
+    char sign = ' ';
+    if(val < 0)
+    {
+        sign = '-';
+        val = (val<0) ? -val : val;
+    }
+    int integer = val / 10;
+    int dec = val % 10;
+    snprintf(buffer, buffer_size, "%c%d.%d %s", sign, integer, dec, unit);
+}
+
+bool set_sound(const unsigned char * string,
+               int* variable,
+               int setting)
+{
+    int talkunit = UNIT_INT;
+    const char* unit = sound_unit(setting);
+    int numdec = sound_numdecimals(setting);
+    int steps = sound_steps(setting);
+    int min = sound_min(setting);
+    int max = sound_max(setting);
+    sound_set_type* sound_callback = sound_get_fn(setting);
+    if (*unit == 'd') /* crude reconstruction */
+        talkunit = UNIT_DB;
+    else if (*unit == '%')
+        talkunit = UNIT_PERCENT;
+    else if (*unit == 'H')
+        talkunit = UNIT_HERTZ;
+    if(!numdec)
+#if CONFIG_CODEC == SWCODEC
+        /* We need to hijack this one and send it off to apps/dsp.c instead of
+                firmware/sound.c */
+                if (setting == SOUND_STEREO_WIDTH)
+                return set_int(string, unit, talkunit,  variable, &stereo_width_set,
+                               steps, min, max, NULL );
     else
-    {
-        /* percent is stored directly -> no conversion */
-        pm_min = global_settings.peak_meter_min;
-        pm_max = global_settings.peak_meter_max;
+#endif   
+                return set_int(string, unit, talkunit,  variable, sound_callback,
+                               steps, min, max, NULL );
+    else
+    {/* Decimal number */
+        selected_setting=setting;
+        return set_int(string, unit, talkunit,  variable, sound_callback,
+                       steps, min, max, &dec_sound_formatter );
     }
-
-    /* apply the range */
-    peak_meter_init_range(global_settings.peak_meter_dbfs, pm_min, pm_max);
 }
-#endif /* HAVE_LCD_BITMAP */
 
-void sound_settings_apply(void)
+ struct value_setting_data {
+     enum optiontype type;
+    int cur_setting; /* current setting as an index in settings list*/
+     /* used for "value" settings.. */
+     int max;
+     int step;
+     int voice_unit;
+     const char * unit;
+     void (*formatter)(char* dest, int dest_length,
+     int variable, const char* unit);
+     /* used for BOOL and "choice" settings */
+     struct opt_items* options;
+ };
+    
+char * value_setting_get_name_cb(int selected_item,void * data, char *buffer)
 {
-    sound_set(SOUND_BASS, global_settings.bass);
-    sound_set(SOUND_TREBLE, global_settings.treble);
-    sound_set(SOUND_BALANCE, global_settings.balance);
-    sound_set(SOUND_VOLUME, global_settings.volume);
-#if CONFIG_CODEC == SWCODEC
-    channels_set(global_settings.channel_config);
-    stereo_width_set(global_settings.stereo_width);
+    struct value_setting_data* cb_data = 
+            (struct value_setting_data*)data;
+    if (cb_data->type == INT && !cb_data->options)
+    {
+        int item = cb_data->max -(selected_item*cb_data->step);
+        if (cb_data->formatter)
+            cb_data->formatter(buffer, MAX_PATH,item,cb_data->unit);
+        else
+            snprintf(buffer, MAX_PATH,"%d %s",item,cb_data->unit);
+    }
+    else strcpy(buffer,P2STR(cb_data->options[selected_item].string));
+    return buffer;
+} 
+void value_setting_icon_cb(int selected_item, void * data, ICON * icon)
+{
+    struct value_setting_data* cb_data = 
+            (struct value_setting_data*)data;
+
+    if (selected_item == cb_data->cur_setting)
+#ifdef HAVE_LCD_BITMAP
+        *icon=bitmap_icons_6x8[Icon_Checkmark];
 #else
-    sound_set(SOUND_CHANNELS, global_settings.channel_config);
-    sound_set(SOUND_STEREO_WIDTH, global_settings.stereo_width);
+        *icon=Icon_Checkmark;
 #endif
-#if (CONFIG_CODEC == MAS3587F) || (CONFIG_CODEC == MAS3539F)
-    sound_set(SOUND_LOUDNESS, global_settings.loudness);
-    sound_set(SOUND_AVC, global_settings.avc);
-    sound_set(SOUND_MDB_STRENGTH, global_settings.mdb_strength);
-    sound_set(SOUND_MDB_HARMONICS, global_settings.mdb_harmonics);
-    sound_set(SOUND_MDB_CENTER, global_settings.mdb_center);
-    sound_set(SOUND_MDB_SHAPE, global_settings.mdb_shape);
-    sound_set(SOUND_MDB_ENABLE, global_settings.mdb_enable);
-    sound_set(SOUND_SUPERBASS, global_settings.superbass);
+    else
+#ifdef HAVE_LCD_BITMAP
+        *icon=0;
+#else
+        *icon=-1;
 #endif
 }
-
-void settings_apply(void)
+void talk_setting(void *global_settings_variable)
 {
-    char buf[64];
-#if CONFIG_CODEC == SWCODEC
-    int i;
-#endif
-
-    sound_settings_apply();
-
-    audio_set_buffer_margin(global_settings.buffer_margin);
-
-#ifdef HAVE_LCD_CONTRAST
-    lcd_set_contrast(global_settings.contrast);
-#endif
-    lcd_scroll_speed(global_settings.scroll_speed);
-#ifdef HAVE_REMOTE_LCD
-    lcd_remote_set_contrast(global_settings.remote_contrast);
-    lcd_remote_set_invert_display(global_settings.remote_invert);
-    lcd_remote_set_flip(global_settings.remote_flip_display);
-    lcd_remote_scroll_speed(global_settings.remote_scroll_speed);
-    lcd_remote_scroll_step(global_settings.remote_scroll_step);
-    lcd_remote_scroll_delay(global_settings.remote_scroll_delay * (HZ/10));
-    lcd_remote_bidir_scroll(global_settings.remote_bidir_limit);
-#ifdef HAVE_REMOTE_LCD_TICKING
-    lcd_remote_emireduce(global_settings.remote_reduce_ticking);
-#endif
-    remote_backlight_set_timeout(global_settings.remote_backlight_timeout);
-#ifdef CONFIG_CHARGING
-    remote_backlight_set_timeout_plugged(global_settings.remote_backlight_timeout_plugged);
-#endif
+    const struct settings_list *setting;
+    int id = -1;
+    if (global_settings.talk_menu == 0)
+        return;
+    setting = find_setting(global_settings_variable);
+    if (setting == NULL)
+        return;
+    if ((setting->flags&F_LANG_IS_STRING) == 0)
+    {
+        id = setting->cfg_lang_id;
+    }
+    if (id != -1)
+        talk_id(id,false);
+}
+    
+ #define type_fromvoidptr(type, value) \
+     (type == INT)? \
+         (int)(*(int*)(value)) \
+     : \
+         (bool)(*(bool*)(value))
+ bool do_set_setting(const unsigned char* string, void *variable,
+                     int nb_items,
+                     struct value_setting_data *cb_data,
+                     void (*function)(int))
+ {
+    int action;
+    bool done = false;
+    struct gui_synclist lists;
+    int oldvalue;
+    bool allow_wrap = true;
+    
+    if (cb_data->type == INT)
+    {
+         oldvalue = *(int*)variable;
+         if (variable == &global_settings.volume)
+             allow_wrap = false;
+    }
+    else oldvalue = *(bool*)variable;
+    
+    gui_synclist_init(&lists,value_setting_get_name_cb,(void*)cb_data,false,1);
+    gui_synclist_set_title(&lists, (char*)string, NOICON);
+    gui_synclist_set_icon_callback(&lists,value_setting_icon_cb);
+    gui_synclist_set_nb_items(&lists,nb_items);
+    gui_synclist_limit_scroll(&lists,true);
+    gui_synclist_select_item(&lists, cb_data->cur_setting);
+    
+    if (global_settings.talk_menu)
+    {
+        if (cb_data->type == INT && !cb_data->options)
+            talk_unit(cb_data->voice_unit, *(int*)variable);
+        else talk_id(cb_data->options[cb_data->cur_setting].voice_id, false);
+    }
+    
+    gui_synclist_draw(&lists);
+    while (!done)
+    {
+        
+        action = get_action(CONTEXT_LIST,TIMEOUT_BLOCK); 
+        if (action == ACTION_NONE)
+            continue;
+        if (gui_synclist_do_button(&lists,action,
+                                   allow_wrap?LIST_WRAP_UNLESS_HELD:LIST_WRAP_OFF))
+        {
+            if (global_settings.talk_menu)
+            {
+                int value;
+                if (cb_data->type == INT && !cb_data->options)
+                {
+                    value = cb_data->max - 
+                            gui_synclist_get_sel_pos(&lists)*cb_data->step;
+                    talk_unit(cb_data->voice_unit, value);
+                }
+                else 
+                {
+                    value = gui_synclist_get_sel_pos(&lists);
+                    talk_id(cb_data->options[value].voice_id, false);
+                }
+            }
+            if (cb_data->type == INT && !cb_data->options)
+                *(int*)variable = cb_data->max - 
+                        gui_synclist_get_sel_pos(&lists)*cb_data->step;
+            else if (cb_data->type == BOOL)
+                *(bool*)variable = gui_synclist_get_sel_pos(&lists) ? true : false;
+            else *(int*)variable = gui_synclist_get_sel_pos(&lists);
+        }  
+        else if (action == ACTION_STD_CANCEL)
+        {
+            gui_syncsplash(HZ/2,true,str(LANG_MENU_SETTING_CANCEL));
+            if (cb_data->type == INT)
+                *(int*)variable = oldvalue;
+            else *(bool*)variable = (bool)oldvalue;
+            done = true;
+        }
+        else if (action == ACTION_STD_OK)
+        {
+            done = true;
+        }
+        else if(default_event_handler(action) == SYS_USB_CONNECTED)
+            return true;
+        gui_syncstatusbar_draw(&statusbars, false);
+        if ( function )
+            function(type_fromvoidptr(cb_data->type,variable));
+    }
+    return false;
+}
+bool set_int(const unsigned char* string,
+             const char* unit,
+             int voice_unit,
+             int* variable,
+             void (*function)(int),
+             int step,
+             int min,
+             int max,
+             void (*formatter)(char*, int, int, const char*) )
+{
+#if CONFIG_KEYPAD != PLAYER_PAD
+    struct value_setting_data data = {
+        INT,(max-*variable)/step,max, step, voice_unit,unit,formatter,NULL };
+    return do_set_setting(string,variable,(max-min)/step + 1,
+                          &data,function);
+#else
+    int count = (max-min)/step + 1;
+    struct value_setting_data data = {
+        INT,count - ((max-*variable)/step),min, -step, voice_unit,unit,formatter,NULL };
+    return do_set_setting(string,variable,count,
+                          &data,function);
+#endif
+}
+
+/* NOTE: the 'type' parameter specifies the actual type of the variable
+   that 'variable' points to. not the value within. Only variables with
+   type 'bool' should use parameter BOOL.
+
+   The type separation is necessary since int and bool are fundamentally
+   different and bit-incompatible types and can not share the same access
+   code. */ 
+bool set_option(const char* string, void* variable, enum optiontype type,
+                const struct opt_items* options, int numoptions, void (*function)(int))
+{
+    struct value_setting_data data = {
+        type,0,0, 0, 0,NULL,NULL,(struct opt_items*)options };
+    if (type == BOOL)
+        data.cur_setting = *(bool*)variable ? 1 : 0;
+    else data.cur_setting = *(int*)variable;
+    return do_set_setting(string,variable,numoptions,
+                          &data,function);
+}
+
+#define MAX_OPTIONS 64
+bool load_setting_screen(struct settings_list *setting)
+{
+    void* variable;
+    int   temp_var = 0;
+    bool ret = false;
+    if(!setting)
+        return false;
+    variable = setting->setting;
+        
+    switch (setting->flags&F_T_MASK)
+    {
+        case F_T_BOOL:
+            if (setting->flags&F_TEMPVARIABLE)
+            {
+                bool temp_v = *(bool*)setting->setting;
+                ret = set_bool(str(setting->cfg_lang_id),&temp_v);
+                if (temp_v != *(bool*)setting->setting)
+                    *(bool*)setting->setting = temp_v;
+            }
+            else ret = set_bool(str(setting->cfg_lang_id),(bool*)variable);
+            break;
+        case F_T_INT:
+        case F_T_UINT:
+            if (setting->flags&F_T_CHOICE)
+            {
+                static struct opt_items options[MAX_OPTIONS];
+                int i, count = setting->nb_values, j=0;
+                bool store_real = setting->flags&F_STOREREALVALUE;
+                for (i=0; i<count && i<MAX_OPTIONS; i++)
+                {
+                    if (setting->flags&F_LANG_STRING)
+                    {
+                        options[j].string = setting->strings[i];
+                        if (settings->talk_id != NULL)
+                            options[j].voice_id = settings->talk_id[i];
+                    }
+                    else 
+                    {
+                        options[j].string = ID2P(setting->values[i]);
+                        options[j].voice_id = setting->values[i];
+                    }
+                    if (store_real)
+                        i++; /* skip the real val for now */
+                    j++;
+                }
+                if (setting->flags&(F_TEMPVARIABLE|F_STOREREALVALUE))
+                {
+                    variable = (void*)&temp_var;
+                    temp_var = *(int*)setting->setting;
+                    if (store_real) /* find the fake value */
+                    {
+                        for (i=1; i<count; i+=2)
+                        {
+                            if (setting->values[i] == temp_var)
+                            {
+                                temp_var = (i/2);
+                                break;
+                            }
+                        }
+                    }
+                    
+                    ret = set_option(ID2P(setting->cfg_lang_id),variable,INT,
+                                     options, j, (void*)setting->function);
+                    if (store_real) /* convert it back to the real value*/
+                    {
+                        temp_var = setting->values[1+(temp_var*2)];
+                    }
+                    if (*(int*)variable != 
+                          *(int*)setting->setting)
+                        *(int*)setting->setting
+                                = *(int*)variable;
+                }
+                else ret = set_option(str(setting->cfg_lang_id),variable,INT,
+                                      options, i, (void*)setting->function);
+            }
+            else if (setting->flags&F_T_SOUND)
+            {
+                ret = set_sound(str(setting->cfg_lang_id),
+                          (int*)variable,setting->values[0]);
+            }
+            else
+            {
+                if (setting->flags&F_TEMPVARIABLE)
+                {
+                    variable = (void*)temp_var;
+                    *(int*)variable = *(int*)setting->setting;
+                }
+                ret = set_int(str(setting->cfg_lang_id),
+                              str(setting->talk_id[0]),setting->talk_id[0],
+                              (int*)variable,(void*)setting->function,
+                              setting->values[2],
+                              setting->values[0],setting->values[1],
+                              (void*)setting->values[3]);
+                if (setting->flags&F_TEMPVARIABLE)
+                {
+                    if (*(int*)variable != 
+                          *(int*)setting->setting)
+                        *(int*)setting->setting
+                                = *(int*)variable;
+                }
+            }
+            break;
+    }
+    
+    return ret;
+}
+
+#ifdef HAVE_LCD_BITMAP
+/**
+ * Applies the range infos stored in global_settings to
+ * the peak meter.
+ */
+void settings_apply_pm_range(void)
+{
+    int pm_min, pm_max;
+
+    /* depending on the scale mode (dBfs or percent) the values
+       of global_settings.peak_meter_dbfs have different meanings */
+    if (global_settings.peak_meter_dbfs)
+    {
+        /* convert to dBfs * 100          */
+        pm_min = -(((int)global_settings.peak_meter_min) * 100);
+        pm_max = -(((int)global_settings.peak_meter_max) * 100);
+    }
+    else
+    {
+        /* percent is stored directly -> no conversion */
+        pm_min = global_settings.peak_meter_min;
+        pm_max = global_settings.peak_meter_max;
+    }
+
+    /* apply the range */
+    peak_meter_init_range(global_settings.peak_meter_dbfs, pm_min, pm_max);
+}
+#endif /* HAVE_LCD_BITMAP */
+
+void sound_settings_apply(void)
+{
+    sound_set(SOUND_BASS, global_settings.bass);
+    sound_set(SOUND_TREBLE, global_settings.treble);
+    sound_set(SOUND_BALANCE, global_settings.balance);
+    sound_set(SOUND_VOLUME, global_settings.volume);
+#if CONFIG_CODEC == SWCODEC
+    channels_set(global_settings.channel_config);
+    stereo_width_set(global_settings.stereo_width);
+#else
+    sound_set(SOUND_CHANNELS, global_settings.channel_config);
+    sound_set(SOUND_STEREO_WIDTH, global_settings.stereo_width);
+#endif
+#if (CONFIG_CODEC == MAS3587F) || (CONFIG_CODEC == MAS3539F)
+    sound_set(SOUND_LOUDNESS, global_settings.loudness);
+    sound_set(SOUND_AVC, global_settings.avc);
+    sound_set(SOUND_MDB_STRENGTH, global_settings.mdb_strength);
+    sound_set(SOUND_MDB_HARMONICS, global_settings.mdb_harmonics);
+    sound_set(SOUND_MDB_CENTER, global_settings.mdb_center);
+    sound_set(SOUND_MDB_SHAPE, global_settings.mdb_shape);
+    sound_set(SOUND_MDB_ENABLE, global_settings.mdb_enable);
+    sound_set(SOUND_SUPERBASS, global_settings.superbass);
+#endif
+}
+
+void settings_apply(bool partial)
+{
+    (void)partial;
+    char buf[MAX_PATH];
+#if CONFIG_CODEC == SWCODEC
+    int i;
+#endif
+
+    sound_settings_apply();
+
+    audio_set_buffer_margin(global_settings.buffer_margin);
+
+#ifdef HAVE_LCD_CONTRAST
+    lcd_set_contrast(global_settings.contrast);
+#endif
+    lcd_scroll_speed(global_settings.scroll_speed);
+#ifdef HAVE_REMOTE_LCD
+    lcd_remote_set_contrast(global_settings.remote_contrast);
+    lcd_remote_set_invert_display(global_settings.remote_invert);
+    lcd_remote_set_flip(global_settings.remote_flip_display);
+    lcd_remote_scroll_speed(global_settings.remote_scroll_speed);
+    lcd_remote_scroll_step(global_settings.remote_scroll_step);
+    lcd_remote_scroll_delay(global_settings.remote_scroll_delay * (HZ/10));
+    lcd_remote_bidir_scroll(global_settings.remote_bidir_limit);
+#ifdef HAVE_REMOTE_LCD_TICKING
+    lcd_remote_emireduce(global_settings.remote_reduce_ticking);
+#endif
+    remote_backlight_set_timeout(global_settings.remote_backlight_timeout);
+#ifdef CONFIG_CHARGING
+    remote_backlight_set_timeout_plugged(global_settings.remote_backlight_timeout_plugged);
+#endif
 #ifdef HAS_REMOTE_BUTTON_HOLD
     remote_backlight_set_on_button_hold(global_settings.remote_backlight_on_button_hold);
 #endif
